#!/usr/bin/env python3

import argparse
from sat import util


def main(args):
    if args.fiel_validar:
        util.fiel_validar(args)
        return

    util.sat_download(args)

    return


def _process_command_line_arguments():
    now = util.today()
    year = now.year

    parser = argparse.ArgumentParser(description='CFDI Descarga SAT')

    help = 'Valida la FIEL'
    parser.add_argument('-fv', '--fiel-validar', help=help,
        action='store_true', default=False, required=False)
    help = 'Ruta al directorio con la FIEL'
    parser.add_argument('-fd', '--fiel-dir', help=help, default='')
    help = "Nombre de los archivos FIEL, el predeterminado es 'fiel'"
    parser.add_argument('-fn', '--fiel-nombre', help=help, default='fiel')

    help = "Descargar por Tipo: t=todos(default), e=emitidas, r=recibidas"
    parser.add_argument('-t', '--tipo', help=help, dest='type', default='t', choices=['t', 'e', 'r'])
    help = "Año de la descarga entre 2014 y el año actual (predeterminado)."
    parser.add_argument('-a', '--año', help=help, dest='year', default=year, type=int, choices=range(2014, year+1))
    help = "Mes de la descarga, el mes actual es el predeterminado"
    parser.add_argument('-m', '--mes', help=help, dest='month', default=0, type=int, choices=range(13))
    help = "Día de la descarga, de forma predeterminada no se usa"
    parser.add_argument('-d', '--dia', help=help, dest='day', default=0, type=int, choices=range(32))

    args = parser.parse_args()
    return args


if __name__ == '__main__':
    args = _process_command_line_arguments()
    main(args)
